%%%%%%%%%%%%%%%%%%%%
% Data application %
%%%%%%%%%%%%%%%%%%%%

n_med=1;                      % 1 if one mediator; 2 if two mediators
PSE='Marginal';                    % if n_med=1: takes the following possible values: 'SY', 'SGY', 'Total', 'Marginal'
                              % if n_med=2: takes the following possible values: 'SY', 'SGY', 'SMY', 'Total', 'Marginal'

tmp=importdata('dat_hcvhbvhcc_survmed2.txt');
Delta1_unsort=tmp.data(:,2);
Y1_unsort=tmp.data(:,1);
logb1=tmp.data(:,end-2);
logb2=tmp.data(:,end-1);
logc=tmp.data(:,end);
logc=logc/0.9;              % From the minimum of logHCV>0 to the 1st quartile

n=length(Delta1_unsort);
cov_unsort=[1+zeros(n,1), tmp.data(:, [6:13])];
q=size(cov_unsort, 2);

if (n_med==2) 
    X_orig=[cov_unsort, logc, logb1, logb2]; 
end;

if (n_med==1) 
    X_orig=[cov_unsort, logc, logb1]; 
end;

nx=n;

X_unsort=X_orig;
lambda=0; sigma2=15;
[Y1,sorti]=sort(Y1_unsort);
Y1=Y1(1:nx,:); 
Delta1=Delta1_unsort(sorti(1:nx)); 
X=X_unsort(sorti(1:nx),:);

if (n_med==1)
    [DD, time3, est3, upp3, low3, theta, var_theta_s, Sf1, Delta, var_Delta, Sdiff, Var_Sdiff]=mediation1(X, Y1, Delta1, PSE, q, sigma2);
    DD 
    1-chi2cdf(DD(1)^2/var_Delta, 1)
end;

if (n_med==2)
    [DD, time3, est3, upp3, low3, time1, est1, upp1, low1, time2, est2, upp2, low2, theta, var_theta_s, Sf1, var_Ddiff]=mediation2(X, Y1, Delta1, PSE, q, sigma2);
    plot(time3, est3, time3, upp3, time3, low3);
    DD
    1-chi2cdf(DD(1)^2/var_Ddiff, 1)
end;

% km=[time1, est1, low1, upp1, time2, est2, low2, upp2, time3, est3, low3, upp3];
% name3=strcat('analysis\omega_', PSE, '_', num2str(n_med), '.csv');
% csvwrite(name3, km);

%THT=[Y1(Delta1==1), log(cumsum(Sf1))];
%csvwrite('analysis\THT.csv', THT);
