n_med=2;
PSE='Total';                  % takes the following possible values: 'SY', 'SGY', 'SMY', 'Total', 'Marginal'

tmp4=importdata('dat_hcvhbvhcc_probit.txt');
Delta_unsort=tmp4.data(:,2);
Y_unsort=tmp4.data(:,1);
logb1=tmp4.data(:,end-2);
logb2=tmp4.data(:,end-1);
logc=tmp4.data(:,end);

n=length(Delta_unsort);
cov_unsort=[1+zeros(n,1), tmp4.data(:, [6:13])];
q=size(cov_unsort, 2);

if (n_med==2) 
    X_orig=[cov_unsort, logc, logb1, logb2]; 
end;
if (n_med==1) 
    X_orig=[cov_unsort, logc, logb1]; 
end;

nx=n;

X_unsort=X_orig;
lambda=0; sigma2=15;
[Y,sorti]=sort(Y_unsort);
Y_forboot=Y(1:end,:); 
Delta_forboot=Delta_unsort(sorti(1:end)); 
X_forboot=X_unsort(sorti(1:end),:);

distance=[];

for boot=0:1:50;
try 

rand('seed',123+boot*137);
select0=unidrnd(sum(Delta_forboot==0), sum(Delta_forboot==0), 1);
select1=unidrnd(sum(Delta_forboot==1), sum(Delta_forboot==1), 1);
which_delta0=find(Delta_forboot==0);
which_delta1=find(Delta_forboot==1);
select=[which_delta0(select0); which_delta1(select1)];
if boot==0; select=(1:1:length(Delta_forboot))'; end;
Y_unsort_b=Y_forboot(select, :);
Delta_unsort_b=Delta_forboot(select);
X_unsort_b=X_forboot(select, :);

[Y, sorti]=sort(Y_unsort_b);
Delta=Delta_unsort_b(sorti);
X=X_unsort_b(sorti,:);

start=min(find(Delta==1));
Y=Y(start:end,:);
Delta=Delta(start:end);
X=X(start:end,:);

[DD, time3, est3, upp3, low3, time1, est1, upp1, low1, time2, est2, upp2, low2, theta, var_theta_s, Sf1, var_Ddiff]=mediation(X, Y, Delta, PSE, q, sigma2);

%%%%%%%%%%%%%%%%%%%%%%%%
% for create all thetas and their SD
% thetatemp=[theta, sqrt(var_theta_s)];
% Thetatemp=[Thetatemp, thetatemp];
% end;
% csvwrite('./data_analysis/thetas.csv', Thetatemp)

[t, ht]=stairs(Y(Delta==1), log(cumsum(Sf1)));
Impuf=[];
for ff=1:1:sum(Delta==0)
    temp=find(Delta==0);
    tempf=temp(ff);
    replf=find(Delta==1);
    impuf=max(replf(replf<tempf));
    Impuf=[Impuf;impuf];
end;
hY=Y;
hY(Delta==1)=log(cumsum(Sf1));
hY(Delta==0)=hY(Impuf);

error=hY+X*theta(end-11:end);

if boot==0;
    error_stdv=sqrt(15);
    error_mean=0;
    error_std=(error-error_mean)/error_stdv;
    [ff0, xx0]=ecdf(error_std, 'censoring', 1-Delta);
    error_sort=sort(ff0);
    error_sort_obs=error_sort;
    norm_sort=normcdf(xx0); 
    distance=[distance; max(abs(error_sort-norm_sort))];
end;

% csvwrite('./data_analysis/thetas_8.csv', theta);

if 1-(boot==0);
    error_stdv=sqrt(15);
    error_std=(error-error_mean)/error_stdv;
    [ff1, xx1]=ecdf(error_std, 'censoring', 1-Delta);
    error_sort=sort(ff1);
    norm_sort=normcdf(xx1);
    dist=[];
    for ss=1:1:length(xx1);
        [minv, ind]=min(abs(xx0-xx1(ss)));
        dist=[dist, abs(ff1(ss)-ff0(ind))];
    end;
    distance=[distance; max(dist)]; 
end;

boot
mean(distance(2:end)>distance(1))
end;
end;

mean(distance(2:end)>distance(1))
% p=0.12 [no. of bootstrap=50]
% plot(norm_sort, error_sort)
% refline(1, 0)
probplot(error_std, 1-Delta);

