function[DD, time3, est3, upp3, low3, theta, var_theta_s, Sf1, Delta, var_Delta, Sdiff, Var_Sdiff]=mediation1(X, Y, Delta, PSE, q, sigma2)

if strcmp(PSE, 'SY') sabc1=[1,0,0]; sabc2=[0,0,0]; end;
if strcmp(PSE, 'SGY') sabc1=[1,1,0]; sabc2=[1,0,0]; end;
if strcmp(PSE, 'SMY') sabc1=[1,1,1]; sabc2=[1,1,0]; end;
if strcmp(PSE, 'Total') sabc1=[1,1,1]; sabc2=[0,0,0]; end;
if strcmp(PSE, 'Marginal') sabc1=[1,1,1]; sabc2=[0,0,0]; end;

rho=1.2; r=1; lambda=0;
n1=length(Delta); p=size(X,2);

SY=sort(Y(Delta==1));
nn=sum(Delta==1); 
indY=(repmat(Y,1,nn)>=repmat(SY',n1,1));
indYc=(repmat(Y,1,nn)<=repmat(SY',n1,1));

if strcmp(PSE, 'Marginal') 
    X_marginal=X(:,1:(end-1));
    nbeta0=size(X_marginal, 2)-1; initial1=[1/nn;0;zeros(nbeta0,1);0];
    p_margin=size(X_marginal, 2);
    [newpar1, Sf1, logf1_unp, DDlogf1_unp, logf1, Dlogf1, DDlogf1_temp,breakid]=NR(Y,Delta,X_marginal,initial1,SY,indY,n1, rho, r, 0, lambda, sigma2); 
    betas=newpar1(2:end); betas=[betas; 0; 0];
    deltas=zeros(1+q,1); sig2_M=0;
    alphas=zeros(2+q,1); sig2_G=0;
    cov_deltas=zeros(1+q, 1+q);
    cov_alphas=zeros(2+q, 2+q);
    invDDlogf1=zeros(size(DDlogf1_temp)+2);
    invDDlogf1([1:q+1, q+4:end], [1:q+1, q+4:end])=inv(DDlogf1_temp);
    DDlogf1=zeros(size(DDlogf1_temp)+2);
    DDlogf1([1:q+1, q+4:end], [1:q+1, q+4:end])=DDlogf1_temp;
    cov_betas=zeros(p+1,p+1);
    cov_betas(1:p_margin,1:p_margin)=inv(-DDlogf1(1:p_margin,1:p_margin));
end;

if 1-strcmp(PSE, 'Marginal') 
    nbeta0=size(X,2)-1; initial1=[1/nn;0;zeros(nbeta0,1);0];
    [newpar1, Sf1, logf1_unp, DDlogf1_unp, logf1, Dlogf1, DDlogf1_temp,breakid]=NR(Y,Delta,X,initial1,SY,indY,n1, rho, r, 0, lambda, sigma2);
    betas=zeros(p+1,1);
    betas([1:(p-1), p+1])=newpar1([2:end]); 

    invDDlogf1=zeros(size(DDlogf1_temp)+1);
    invDDlogf1([1:q+1, q+3:end], [1:q+1, q+3:end])=inv(DDlogf1_temp);
    cov_betas=zeros(p+1,p+1);
    cov_betas([1:q+1, q+3:p+1], [1:q+1, q+3:p+1])=inv(-DDlogf1_temp(1:p,1:p));

    [alphas_temp, cov_alphas_temp, sig2_G]=normeq(X(:,[1:q, p-1]), X(:,p));
    alphas=[alphas_temp; 0]; cov_alphas=zeros(2+q, 2+q); 
    cov_alphas(1:end-1, 1:end-1)=cov_alphas_temp; 
    deltas=zeros(1+q, 1); sig2_M=0; cov_deltas=zeros(1+q, 1+q);
end;

theta=[deltas; alphas; betas]; 
cov_theta=blkdiag(cov_deltas, cov_alphas, -invDDlogf1);
cov_theta_s=blkdiag(cov_deltas, cov_alphas, cov_betas);
var_theta_s=diag(cov_theta_s);
Xcov=mean(X(:, 1:q));

[G1, der1, eta1, sig2_med1, dereta1]=cal_der(sabc1(1), sabc1(2), sabc1(3), deltas, alphas, betas, Sf1, sig2_M, sig2_G, Xcov);
[G2, der2, eta2, sig2_med2, dereta2]=cal_der(sabc2(1), sabc2(2), sabc2(3), deltas, alphas, betas, Sf1, sig2_M, sig2_G, Xcov);

% For survival function
if strcmp(PSE, 'Marginal') 
    der1(1:2*q+3,:)=0;
    der2(1:2*q+3,:)=0;
end;
if 1-strcmp(PSE, 'Marginal') 
    der1(1:1*q+1,:)=0;
    der2(1:1*q+1,:)=0;
end;

derdiff=der1-der2;

Var_S1=zeros(nn, 1); Var_S2=zeros(nn, 1); Var_Sdiff=zeros(nn, 1);
for k=1:1:nn
    der1k=der1(:,k);
    der2k=der2(:,k);
    derdiffk=derdiff(:,k);
    var_S1=der1k'*cov_theta*der1k;
    var_S2=der2k'*cov_theta*der2k;
    var_Sdiff=derdiffk'*cov_theta*derdiffk;
    Var_S1(k,:)=var_S1;
    Var_S2(k,:)=var_S2;
    Var_Sdiff(k,:)=var_Sdiff;
end
[time1, est1]=stairs(Y(Delta==1), exp(-G1));
[time1, low1]=stairs(Y(Delta==1), exp(-G1)-1.96*sqrt(Var_S1));
[time1, upp1]=stairs(Y(Delta==1), exp(-G1)+1.96*sqrt(Var_S1));
[time2, est2]=stairs(Y(Delta==1), exp(-G2));
[time2, low2]=stairs(Y(Delta==1), exp(-G2)-1.96*sqrt(Var_S2));
[time2, upp2]=stairs(Y(Delta==1), exp(-G2)+1.96*sqrt(Var_S2));
[time3, est3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2));
[time3, low3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2)-1.96*sqrt(Var_Sdiff));
[time3, upp3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2)+1.96*sqrt(Var_Sdiff));

Sdiff=exp(-G1)-exp(-G2);

plot(time3, est3, time3, low3, time3, upp3)

% For Delta's (i.e., difference in H(T))

Ddiff=-dereta1+dereta2;
var_Ddiff=Ddiff*cov_theta_s*Ddiff';
DD=[-eta1+eta2, -eta1+eta2-1.96*sqrt(var_Ddiff), -eta1+eta2+1.96*sqrt(var_Ddiff)];
Delta=-eta1+eta2;
var_Delta=var_Ddiff;
